package com.base.scanqrclear.ui.telephone

import android.Manifest
import android.content.Intent
import androidx.activity.addCallback
import androidx.core.view.updatePadding
import androidx.lifecycle.ViewModelProvider
import com.base.scanqrclear.R
import com.base.scanqrclear.ads.AdsMgr
import com.base.scanqrclear.ads.AdsShowCallBack
import com.base.scanqrclear.base.BaseActivity
import com.base.scanqrclear.bean.FunctionUIBean
import com.base.scanqrclear.bean.FunctionUIBean.Companion.KEY_TELEPHONE
import com.base.scanqrclear.bean.TelephoneUIBean
import com.base.scanqrclear.bean.config.AdConfigBean
import com.base.scanqrclear.databinding.ActivityTelephoneCodeBinding
import com.base.scanqrclear.ui.exportpdf.ExportPdfActivity
import com.base.scanqrclear.ui.vm.QrViewModel
import com.base.scanqrclear.ui.widget.InputNameDialog.showInputNameDialog
import com.base.scanqrclear.utils.BarUtils
import com.base.scanqrclear.utils.BitmapUtils.saveBitmapToFile
import com.base.scanqrclear.utils.ClipboardUtils.copyText
import com.base.scanqrclear.utils.IntentUtils.intentCallPhone
import com.base.scanqrclear.utils.IntentUtils.intentShareImage
import com.base.scanqrclear.utils.LogEx
import com.base.scanqrclear.utils.PermissionUtils.checkCallPhonePermission
import com.base.scanqrclear.utils.QRCodeUtils.generateQRCode
import com.base.scanqrclear.utils.SpJsonUtils
import com.base.scanqrclear.utils.ToastUtils.toast
import com.google.gson.Gson
import java.io.File

class TelephoneCodeActivity : BaseActivity<ActivityTelephoneCodeBinding>(ActivityTelephoneCodeBinding::inflate) {

    private var telephoneUIBean = TelephoneUIBean()
    private var qrString = ""
    private var tempImagePath: String = ""

    private val viewModel by lazy(LazyThreadSafetyMode.NONE) {
        ViewModelProvider(this)[QrViewModel::class.java]
    }

    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        val flag = changeLanguage()
        if (flag) return

        AdsMgr.showBanner(binding.flBanner, false)
    }


    override fun initView() {
        super.initView()

        binding.clTop.updatePadding(top = BarUtils.getStatusBarHeight())
        AdsMgr.showNative(binding.flAd, R.layout.layout_admob_item)

        val data = intent.extras?.getString("data")

        data?.let {
            telephoneUIBean = Gson().fromJson(data, TelephoneUIBean::class.java)
            binding.tvTel.text = telephoneUIBean.tel
            qrString = "tel:" + telephoneUIBean.tel
        }

        Thread {
            val bitmap = generateQRCode(qrString, 735, 735, 5)
            runOnUiThread {
                binding.ivQr.setImageBitmap(bitmap)
                val file = File(cacheDir, System.currentTimeMillis().toString() + ".jpg")
                bitmap?.let {
                    val flag = saveBitmapToFile(it, file.absolutePath)
                    LogEx.logDebug(TAG, "flag=$flag tempImage=${file.absolutePath}")
                    if (flag) {
                        tempImagePath = file.absolutePath
                    }
                }
                if (telephoneUIBean.needCreate) {
                    telephoneUIBean.needCreate = false
                    SpJsonUtils.addJsonBean<TelephoneUIBean>(FunctionUIBean.KEY_TELEPHONE, telephoneUIBean)
                }
            }
        }.start()
    }

    override fun initListener() {
        super.initListener()
        onBackPressedDispatcher.addCallback {
            if (AdConfigBean.adsConfigBean.functionBackShowAd) {
                AdsMgr.showInsert(this@TelephoneCodeActivity, false, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        finishToMainTop()
                    }

                    override fun failed(where: Int) {
                        finishToMainTop()
                    }

                    override fun googleFailed(where: Int) {
                        finishToMainTop()
                    }
                })
            } else {
                finishToMainTop()
            }
        }
        binding.flBack.setOnClickListener {
            onBackPressedDispatcher.onBackPressed()
        }
        binding.llShare.setOnClickListener {
            val intent = intentShareImage(this, tempImagePath)
            runCatching {
                startActivity(intent)
            }
        }
        binding.llDownload.setOnClickListener {
            if (AdConfigBean.adsConfigBean.functionUseShowAd) {
                AdsMgr.showInsert(this, true, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        useDownload()
                    }

                    override fun failed(where: Int) {
                        useDownload()
                    }

                    override fun googleFailed(where: Int) {
                        useDownload()
                    }
                })
            } else {
                useDownload()
            }
        }
        binding.llCopy.setOnClickListener {
            copyText(TAG, qrString)
            toast("Copied to clipboard", true)
        }
        binding.flSearch.setOnClickListener {
            if (!checkCallPhonePermission()) {
                launcher.launch(arrayOf(Manifest.permission.CALL_PHONE)) {
                    if (checkCallPhonePermission()) {
                        if (AdConfigBean.adsConfigBean.functionUseShowAd) {
                            AdsMgr.showInsert(this, true, object : AdsShowCallBack() {
                                override fun close(where: Int) {
                                    callPhone()
                                }

                                override fun failed(where: Int) {
                                    callPhone()
                                }

                                override fun googleFailed(where: Int) {
                                    callPhone()
                                }
                            })
                        } else {
                            callPhone()
                        }
                    }
                }
            } else {
                if (AdConfigBean.adsConfigBean.functionUseShowAd) {
                    AdsMgr.showInsert(this, true, object : AdsShowCallBack() {
                        override fun close(where: Int) {
                            callPhone()
                        }

                        override fun failed(where: Int) {
                            callPhone()
                        }

                        override fun googleFailed(where: Int) {
                            callPhone()
                        }
                    })
                } else {
                    callPhone()
                }
            }
        }
        binding.llPdf.setOnClickListener {
            startActivity(Intent(this, ExportPdfActivity::class.java).apply {
                putExtra("qrType", KEY_TELEPHONE)
                putExtra("qrString", qrString)
            })
        }
    }

    private fun callPhone() {

        try {
            val intent = intentCallPhone(telephoneUIBean.tel)
            startActivity(intent)
        } catch (e: Exception) {
            toast("No application was found to handle the phone call", true)
        }

    }

    private fun useDownload() {
        kotlin.runCatching {
            val newName = File(tempImagePath).name
            showInputNameDialog(newName) { name ->
                viewModel.copyFileToDownloads(this, name, tempImagePath)
            }
        }
    }

}